/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.robokind.impl.motion.dynamixel.properties;

import org.robokind.api.common.position.IntegerRange;
import org.robokind.api.common.position.NormalizableRange;
import org.robokind.api.common.position.NormalizedDouble;
import org.robokind.api.motion.JointProperty;
import org.robokind.impl.motion.dynamixel.DynamixelServo;

/**
 *
 * @author matt
 */
public class AbsolutePositionProperty extends JointProperty.ReadOnly<Integer>{
    private DynamixelServo myServo;
    
    public AbsolutePositionProperty(DynamixelServo servo){
        myServo = servo;
    }

    @Override
    public String getPropertyName() {
        return "absGoalPosition";
    }

    @Override
    public String getDisplayName() {
        return "Absolute Goal Postion";
    }

    @Override
    public Class<Integer> getPropertyClass() {
        return Integer.class;
    }

    @Override
    public Integer getValue() {
        double min = myServo.getConfig().getMinPosition();
        double max = myServo.getConfig().getMaxPosition();
        NormalizedDouble val = myServo.getGoalPosition();
        if(val == null){
            return null;
        }
        double cur = val.getValue();
        double range = max - min;
        cur = cur*range + min;
        return (int)cur;
    }
    
    @Override
    public NormalizableRange<Integer> getNormalizableRange() {
        return new IntegerRange(0, 1023);
    }
}
